/**
* Module:  Demo for the XK-1
* Version: rev 0.1
* File:    test.xc
*
* The copyrights, all other intellectual and industrial
* property rights are retained by XMOS and/or its licensors.
* Terms and conditions covering the use of this code can
* be found in the Xmos End User License Agreement.
*
* Copyright XMOS Ltd 2009
**/


#include <xs1.h>
#include <print.h>
#include <platform.h>

// LEDs
#define IO_CORE 0
on stdcore[0] : out port p_core0_leds_3_0 = XS1_PORT_4F;
on stdcore[1] : out port p_core1_leds_3_0 = XS1_PORT_4F;



#define DELAY 5000000


int main_core0(chanend c)
{
  timer t;
  int time;
  
  printstr("Hello World0!\n");

  
  t :> time;
  while (1)
  {
    for (int i=0; i<8; i++)
    {
      c <: (1<<i)>>4;
      p_core0_leds_3_0 <: 1<<i;
      time += DELAY;
      t when timerafter(time) :> int _;
    }
    for (int i=0; i<8; i++)
    {
      c <: (1<<(8-i))>>4;
      p_core0_leds_3_0 <: 1<<(8-i);
      time += DELAY;
      t when timerafter(time) :> int _;
    }
  }
  
  
  return 0;
}

int main_core1(chanend c)
{  
  int val;

  printstr("Hello World1!\n");
  while (1)
  {

    c :> val;
    p_core1_leds_3_0 <: val;
    
  }
  
  return 0;
}

int main()
{
  chan c;
  par
  {
    on stdcore[0] : main_core0(c);
    on stdcore[1] : main_core1(c);
  }
  return 0;
}
